import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * Write a description of class LineOfSight here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class LineOfSight extends Actor
{
    Guard guard;
    GreenfootImage img = new GreenfootImage(30,30);

    public LineOfSight(Guard guardReference)
    {
        guard = guardReference;

    }

    /**
     * Act - do whatever the LineOfSight wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        drawLineOfSight();
        alignImage();
    }    

    /**
     * Aligns the polygon with the 
     */
    public void alignImage()
    {
        if ("north".equals(guard.direction)){
            setLocation(guard.getX(), guard.getY() - 1);
        }
        else if ("south".equals(guard.direction)){
            setLocation(guard.getX(), guard.getY() + 1);
        }
        else if ("east".equals(guard.direction)){
            setLocation(guard.getX() + 1, guard.getY());
        }   
        else if ("west".equals(guard.direction)){
            setLocation(guard.getX()  - 1, guard.getY());
        }
    }

    public void drawLineOfSight()
    {
        img.setColor(Color.BLUE);
        if ("north".equals(guard.direction)){
            img.clear();
            int xOffset1 = 5;
            int xOffset2 = 10;
            int yOffset1 = 4;
            int yOffset2 = 45;
            int[] xArray= {xOffset1, -xOffset1, -xOffset2, xOffset2};
            int[] yArray= {-yOffset1, -yOffset1, -yOffset2, -yOffset2};
            img.fillPolygon(xArray, yArray, 4);
            setImage(img);
        }
        else if ("south".equals(guard.direction)){
            img.clear();
            int xOffset1 = 5;
            int xOffset2 = 10;
            int yOffset1 = 4;
            int yOffset2 = 45;
            int[] xArray= {xOffset1, -xOffset1, -xOffset2, xOffset2};
            int[] yArray= {yOffset1, yOffset1, yOffset2, yOffset2};
            img.fillPolygon(xArray, yArray, 4);
            setImage(img);
        }
        else if ("east".equals(guard.direction)){
            img.clear();
            int xOffset1 = 4;
            int xOffset2 = 45;
            int yOffset1 = 10;
            int yOffset2 = 5;
            int[] xArray= {xOffset1, xOffset1, xOffset2, xOffset2};
            int[] yArray= {yOffset1, -yOffset1, -yOffset2, yOffset2,};
            img.fillPolygon(xArray, yArray, 4);
            setImage(img);
        }   
        else if ("west".equals(guard.direction)){
            img.clear();
            int xOffset1 = 4;
            int xOffset2 = 45;
            int yOffset1 = 10;
            int yOffset2 = 5;
            int[] xArray= {-xOffset1, -xOffset1, -xOffset2, -xOffset2};
            int[] yArray= {yOffset1, -yOffset1, -yOffset2, yOffset2,};
            img.fillPolygon(xArray, yArray, 4);
            setImage(img);
        }
    }
}
