import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Room here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Room extends SWorld
{

    /**
     * Constructor for objects of class Room.
     * 
     */
    public Room()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(600, 450, 1, 1200, 900); 

        prepare();
        
        setPaintOrder(LineOfSight.class, Player.class, Guard.class, Stairs.class);
    }

    /**
     * Prepare the world for the start of the program. That is: create the initial
     * objects and add them to the world.
     */
    private void prepare()
    {
        addMainActor(new Player(1), 620, 700, 0, 0);
        
        GreenfootImage bg = new GreenfootImage("background.png");
        setScrollingBackground(bg);
        
        Area area1 = new Area("square");
        addObject(area1, 480, 490, true);
        Area area2 = new Area("square");
        addObject(area2, 600, 500, true);
        Area area3 = new Area("square");
        addObject(area3, 700, 500, true);
        Area area4 = new Area("square");
        addObject(area4, 775, 500, true);
        
        Guard guard = new Guard(area1);
        addObject(guard, 480, 490, true);
        Guard guard2 = new Guard(area2);
        addObject(guard2, 600, 500, true);
        Guard guard3 = new Guard(area3);
        addObject(guard3, 700, 500, true);
        Guard guard4 = new Guard(area4);
        addObject(guard4, 775, 500, true);
        
        LineOfSight lineOfSight = new LineOfSight(guard);
        addObject(lineOfSight, 480, 490, true);
        LineOfSight lineOfSight2 = new LineOfSight(guard2);
        addObject(lineOfSight2, 600, 500, true);
        LineOfSight lineOfSight3 = new LineOfSight(guard3);
        addObject(lineOfSight3, 700, 500, true);
        LineOfSight lineOfSight4 = new LineOfSight(guard4);
        addObject(lineOfSight4, 775, 500, true);
    }
}
